#!/usr/bin/php
<?php
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}
// This script will output a meterN compatible format for the main command
// You'll need to setup the path to meterN ($pathtomn). Put the meters numbers ($metnum) and the corresponding command ($cmd) :

$pathtomn = '/srv/http/metern';
$noerr    = false;

if (isset($argv[1])) {
    if ($argv[1] == 'elect') {
        $metnum = 1;
        $cmd    = "poolmeters relect"; // Request counters values during a 5 min period
        $noerr  = true;
    } elseif ($argv[1] == 'gas') {
        $metnum = 2;
        $cmd    = "poolmeters rgas";
        $noerr  = true;
    } elseif ($argv[1] == 'water') {
        $metnum = 3;
        $cmd    = "poolmeters rwater";
        $noerr  = true;
    } else {
        die("Abording: no valid argument given\n");
    }
} else {
    die("Usage: pooler { elect | gas | water }\n");
}

if ($noerr) {
    define('checkaccess', TRUE);
    include("$pathtomn/config/config_main.php");
    include("$pathtomn/config/config_met$metnum.php");
    
    // Retrieve previous value in the last daily csv
    $dir    = "$pathtomn/data/csv/";
    $output = glob($dir . '*.csv');
    sort($output);
    $csvcnt = count($output);
    
    if ($csvcnt > 0) {
        $file = file($output[$csvcnt - 1]);
        $cnt  = count($file);
        
        $i = 0;
        while (!isset($prevval)) {
            $i++;
            $array = preg_split('/,/', $file[$cnt - $i]);
            if (!empty($array[$metnum])) {
                $prevval = $array[$metnum];
            }
            if ($i == $cnt) {
                $prevval = 0; // didn't find any prev. value
            }
        }
        // Now retrieve the current value
        $datareturn = shell_exec($cmd);
        $datareturn = trim($datareturn);
        $datareturn = preg_replace("/^${'ID'.$metnum}\(/i", '', $datareturn); // VALUE*UNIT)
        $lastval    = preg_replace("/\*[a-z0-9]+\)$/i", '', $datareturn); // VALUE
        
        if ($argv[1] == 'gas' && $lastval > 0.5) { // impossible to get so many pulses
            $lastval = 0;
        }
        
        settype($lastval, 'float');
        settype($prevval, 'float');
        $lastval += $prevval;
        
        if (${'PASSO' . $metnum} > 0 && $lastval > ${'PASSO' . $metnum}) { // counter pass over
            $lastval -= ${'PASSO' . $metnum};
        }
        $lastval = round($lastval, ${'PRECI' . $metnum});
    } else {
        $lastval = 0;
    }
    
    $str = utf8_decode("${'ID'.$metnum}($lastval*${'UNIT'.$metnum})\n");
    echo "$str";
}
?>
